#include <stdio.h>
#include <math.h>
#define n1   29000            // X,n1
#define n2   17000            // Y,n2
#define scale 15.0            // extract from *.fit in step of 15 aecsec/pixel
#define f1  "12:50:00"        // R.A. center
#define f2  "64:00:00"        // DEC. center
//                                                 /15,*0.454;   
// 182,70--->(4096+182)*2,(4032+70)*2-->8556,8204; --> 259,248
// 25"   --->        55 pixel       --->8501,8149; --> 257,247 
// 123*121 11 123*121
//    5          5     > 257*247  >>  357*357
// 123*121 11 123*121     
char   a[357][357],d[357][357];
// a[][] is constant patten x1=50; y1=60;
// a-->d, turn a angle,  bb+=d[][]
// angle: calcul 4 corner's radec --> X,Y ---> get angle
int    m1=8501, m2=8149;
float  bokscale=0.454;
char   b[130],head[72][80];
char   c1[14],c2[14];
double a8[8],b8[8];
double u8[8],v8[8];
double xx[5],yy[5];
int    ixx[5],iyy[5];
double rc1,dc1,rc2,dc2;
double hs2, pi,pi2,cx,cy;
FILE   *fp;
unsigned char  bb[n2][n1];
main(int ac, char **av)
{
  int    i,j,k,i1,j1,ip;
  double x,y,a1,d1,x1,y1;
  for(j=0;j<357;j++)for(i=0;i<357;i++)a[j][i]=0;
  for(j= 55;j<176;j++){ for(i= 50;i<173;i++)a[j][i]=1;
                        for(i=184;i<307;i++)a[j][i]=1; }
  for(j=181;j<302;j++){ for(i= 50;i<173;i++)a[j][i]=1;
                        for(i=184;i<307;i++)a[j][i]=1; }
  if(ac<2){
     printf("\n\t****** produce bass_tile.fit \n");
     printf("\n\tUsage: v_84   [!]\n\n\n");
     exit(0);
  }
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.; pi2=pi/2.;
  for(j=0;j<n2;j++)for(i=0;i<n1;i++)bb[j][i]=0;
  printf("center:  %s %s\n",f1,f2);
  chs(f1,&rc1); chs(f2,&dc1); 
  rc1*=cx; dc1*=cy; a8[6]=rc1; a8[7]=dc1;  
  hs2=(3600.*180./pi)/scale;                 
  b8[0]=-hs2; b8[1]=b8[2]=0; b8[3]=-b8[0]; b8[4]=n1/2; b8[5]=n2/2;
  xytoad(b8,a8);
   
  x=n1/2.; y=n2/2.;  xy_rad(a8,rc1,dc1,x,y,&a1,&d1,1,0);
  toms2(a1,c1,1); toms2(d1,c2,0);
  rad_xy(b8,rc1,dc1,a1,d1,&x1,&y1,0,0);
  printf("%8.1lf %8.1lf %s %s %8.1lf %8.1lf\n",x,y,c1,c2,x1,y1);
   
  x=n1;    y=n2;     xy_rad(a8,rc1,dc1,x,y,&a1,&d1,1,0);
  toms2(a1,c1,1); toms2(d1,c2,0); 
  rad_xy(b8,rc1,dc1,a1,d1,&x1,&y1,1,0);
  printf("%8.1lf %8.1lf %s %s %8.1lf %8.1lf\n",x,y,c1,c2,x1,y1);

  x=1;     y=n2;     xy_rad(a8,rc1,dc1,x,y,&a1,&d1,1,0);
  toms2(a1,c1,1); toms2(d1,c2,0);
  rad_xy(b8,rc1,dc1,a1,d1,&x1,&y1,1,0);
  printf("%8.1lf %8.1lf %s %s %8.1lf %8.1lf\n",x,y,c1,c2,x1,y1);

  x=n1;    y=1;      xy_rad(a8,rc1,dc1,x,y,&a1,&d1,1,0);
  toms2(a1,c1,1); toms2(d1,c2,0); 
  rad_xy(b8,rc1,dc1,a1,d1,&x1,&y1,1,0);
  printf("%8.1lf %8.1lf %s %s %8.1lf %8.1lf\n",x,y,c1,c2,x1,y1);

  x=1;     y=1;      xy_rad(a8,rc1,dc1,x,y,&a1,&d1,1,0);
  toms2(a1,c1,1); toms2(d1,c2,0); 
  rad_xy(b8,rc1,dc1,a1,d1,&x1,&y1,1,0);
  printf("%8.1lf %8.1lf %s %s %8.1lf %8.1lf\n",x,y,c1,c2,x1,y1);
printf("=============\n");
  x=n1/2;     y=1;      xy_rad(a8,rc1,dc1,x,y,&a1,&d1,1,0);
  toms2(a1,c1,1); toms2(d1,c2,0); 
  rad_xy(b8,rc1,dc1,a1,d1,&x1,&y1,1,0);
  printf("%8.1lf %8.1lf %s %s %8.1lf %8.1lf\n",x,y,c1,c2,x1,y1);

  x=n1/2;     y=n2;      xy_rad(a8,rc1,dc1,x,y,&a1,&d1,1,0);
  toms2(a1,c1,1); toms2(d1,c2,0); 
  rad_xy(b8,rc1,dc1,a1,d1,&x1,&y1,1,0);
  printf("%8.1lf %8.1lf %s %s %8.1lf %8.1lf\n",x,y,c1,c2,x1,y1);

  x=1;     y=n2/2;      xy_rad(a8,rc1,dc1,x,y,&a1,&d1,1,0);
  toms2(a1,c1,1); toms2(d1,c2,0); 
  rad_xy(b8,rc1,dc1,a1,d1,&x1,&y1,1,0);
  printf("%8.1lf %8.1lf %s %s %8.1lf %8.1lf\n",x,y,c1,c2,x1,y1);

  x=n1;     y=n2/2;      xy_rad(a8,rc1,dc1,x,y,&a1,&d1,1,0);
  toms2(a1,c1,1); toms2(d1,c2,0); 
  rad_xy(b8,rc1,dc1,a1,d1,&x1,&y1,1,0);
  printf("%8.1lf %8.1lf %s %s %8.1lf %8.1lf\n",x,y,c1,c2,x1,y1);

  fp=fopen("bass_tiles.txt","r");
l10:
  fgets(b,130,fp); if(feof(fp))goto l20;
  if(b[0]=='#')goto l10;
  sscanf(b,"%d %lf %lf",&ip,&rc2,&dc2);
  rc2/=15.;
//  rad_xy(b8,rc1,dc1,rc2,dc2,&x1,&y1,1,0); // as Schmidt tel.
//  i1=x1+0.5; j1=y1+0.5;
//  printf("%4d %6.3lf %6.3lf %5d %5d\n",ip,a1,d1,i1,j1);
//  if(i1>kx && i1<n1-kx && j1>ky && j1<n2-ky)
//int kx=128,ky=123;
//  for(j=j1-ky;j<j1+ky;j++)for(i=i1-kx;i<i1+kx;i++)bb[j][i]=1;
  rc2*=cx; dc2*=cy; u8[6]=rc2; u8[7]=dc2;
  hs2=(3600.*180./pi)/bokscale;
  v8[0]=-hs2; v8[1]=v8[2]=0; v8[3]=-v8[0]; v8[4]=(m1+1)/2.; v8[5]=(m2+1)/2.;
  xytoad(v8,u8);
  x=1.; y=m2;        xy_rad(u8,rc2,dc2,x,y,&a1,&d1,2,0);
                     rad_xy(b8,rc1,dc1,a1,d1,&xx[0],&yy[0],1,0);
  x=1.; y=1.;        xy_rad(u8,rc2,dc2,x,y,&a1,&d1,2,0);
                     rad_xy(b8,rc1,dc1,a1,d1,&xx[1],&yy[1],1,0);
  x=m1; y=m2;        xy_rad(u8,rc2,dc2,x,y,&a1,&d1,2,0);
                     rad_xy(b8,rc1,dc1,a1,d1,&xx[2],&yy[2],1,0);
  x=m1; y=1.;        xy_rad(u8,rc2,dc2,x,y,&a1,&d1,2,0);
                     rad_xy(b8,rc1,dc1,a1,d1,&xx[3],&yy[3],1,0);
  x=v8[4]; y=v8[5];  xy_rad(u8,rc2,dc2,x,y,&a1,&d1,2,0);
                     rad_xy(b8,rc1,dc1,a1,d1,&xx[4],&yy[4],1,0);
  for(j=0;j<5;j++){ ixx[j]=xx[j]+0.5; iyy[j]=yy[j]+0.5; }
  printf("%4d:",ip);
  for(j=0;j<4;j++)printf("%6d%6d ",ixx[j]-ixx[4],iyy[j]-iyy[4]); 
  x=xx[0]-xx[1]; y=yy[0]-yy[1];
  i1=sqrt(x*x+y*y)+0.5;
  x=xx[0]-xx[2]; y=yy[0]-yy[2];
  j1=sqrt(x*x+y*y)+0.5;
printf("%3d%4d\n",i1,j1);
  
  goto l10;
l20:
  fclose(fp);
  puthead();
  fp=fopen("v_84.fit","wb");
  fwrite(head,72,80,fp); fwrite(bb,n1,n2,fp); fclose(fp);
  printf("\nproduce file: v_84.fit    ok!\n");
}

puthead()
{
  int i,k;
  double x;
  for(i=0;i<72;i++)for(k=0;k<80;k++)head[i][k]=32;
  strcpy(&head[ 0][0], "SIMPLE  =                    T ");
  strcpy(&head[ 1][0], "BITPIX  =                    8 ");
  strcpy(&head[ 2][0], "NAXIS   =                    2 ");
  sprintf(&head[3], "NAXIS1  =                %5d ",n1);
  sprintf(&head[4], "NAXIS2  =                %5d ",n2);
  strcpy(&head[ 8][0], "DATE-OBS=        2011,09,18~24 ");
  strcpy(&head[ 9][0], "TIME-OBS=                      ");
  strcpy(&head[10][0], "EXPTIME =                  150 ");
  toms2(rc1/cx,c1,1); toms2(dc1/cy,c2,0);
  sprintf(&head[11],"RA      =        %s ", c1);
  sprintf(&head[12],"DEC     =         %s ",c2);
  strcpy(&head[13][0], "HA      =                      ");
  strcpy(&head[14][0], "EPOCH   =               2000.0 ");
  strcpy(&head[15][0], "FILTER  =                    u ");
  strcpy(&head[18][0], "INSTRUME=        BOK   90prime ");
  k=34;
  sprintf(&head[k++],"A81     = %20.12le ",a8[0]);
  sprintf(&head[k++],"A82     = %20.12le ",a8[1]);
  sprintf(&head[k++],"A83     = %20.12le ",a8[2]);
  sprintf(&head[k++],"A84     = %20.12le ",a8[3]);
  sprintf(&head[k++],"A85     = %20.12le ",a8[4]);
  sprintf(&head[k++],"A86     = %20.12le ",a8[5]);
  sprintf(&head[k++],"A87     = %20.12le ",a8[6]);
  sprintf(&head[k++],"A88     = %20.12le ",a8[7]);

  k=48;
  x=(a8[1]+a8[2])/(a8[0]-a8[3])/cy;       // BOKs
  sprintf(&head[k++],"CTYPE1  = 'RA---ARC'           ");
  sprintf(&head[k++],"CTYPE2  = 'DEC--ARC'           ");
  sprintf(&head[k++],"CROTA2  =  %16.8le    ",x);
  sprintf(&head[k++],"CRVAL1  =  %16.8le    ",rc1/cy);
  sprintf(&head[k++],"CRVAL2  =  %16.8le    ",dc1/cy);
  sprintf(&head[k++],"CDELT1  =  %16.8le    ",a8[0]/cy);
  sprintf(&head[k++],"CDELT2  =  %16.8le    ",a8[3]/cy);
  sprintf(&head[k++],"CRPIX1  =  %16.8le    ",(n1+1)/2.);
  sprintf(&head[k++],"CRPIX2  =  %16.8le    ",(n2+1)/2.);
// while nei_cha, use ix0,iy0, not ix1.iy1. record_down a[][], lost halt pixel 
  for(i=0;i<70;i++)if(head[i][0]!=32)head[i][31]='/';
  strcpy(&head[71][0], "END"); head[71][3]=32;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

#define bok  48.
rad_xy(b8,ac,dc,ra,de,x,y,type,k)
double *b8,ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
/*                         // same discribe formula as following 3 lines
  double sd,cd,td,co;      // china bai_ke_quan_shu (astronmy) p.552
  sd=sin(dc);  cd=cos(dc);  td=tan(der);
  co=cos(rar-ac);  tmp=sd*td+cd*co;
  xi=sin(rar-ac)/tmp;
  xn=(cd*td-sd*co)/tmp;
*/
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

xy_rad(a8,ac,dc,x,y,ra,de,type,k)
double *a8,ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);

    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc;
  if(tmp<0.)tmp=-tmp;
  if(tmp>pi2){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
/*
 hour or degree to char_line
 if k=1 (hour case) in **:**:**.***
    k=0 (degree       -**:**:**.**
*/
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}
